package combatmanager;

import javax.swing.*;
import javax.swing.text.AbstractDocument;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Size1DDialog extends JDialog {

    public static final int OK_RESULT = 0;
    public static final int CANCEL_RESULT = 1;

    private static final Insets FIVE_ON_SIDES = new Insets(5, 5, 5, 5);

    private final JPanel panel;
    private final JLabel message;
    private final JTextField field;
    private final JButton ok;
    private final JButton cancel;
    private int result;

    public Size1DDialog(Window parent, String message, int size) {
        super(parent, "Enter Size");
        setResizable(false);
        setAlwaysOnTop(true);
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                result = CANCEL_RESULT;
                dispose();
            }
        });
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        setModalityType(ModalityType.APPLICATION_MODAL);
        this.message = new JLabel(message);
        field = new JTextField(String.valueOf(size), 4);
        ((AbstractDocument) field.getDocument()).setDocumentFilter(CombatManager.digitFilter);
        ok = new JButton("Ok");
        ok.addActionListener(e -> {
            result = OK_RESULT;
            dispose();
        });
        cancel = new JButton("Cancel");
        cancel.addActionListener(e -> {
            result = CANCEL_RESULT;
            dispose();
        });
        panel = new JPanel(new GridBagLayout());
        panel.add(this.message, new GridBagConstraints(0, 0, 2, 1, 0.2, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, FIVE_ON_SIDES, 0, 0));
        panel.add(field, new GridBagConstraints(2, 0, GridBagConstraints.REMAINDER, 1, 0.4, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, FIVE_ON_SIDES, 0, 0));
        panel.add(ok, new GridBagConstraints(0, 1, 1, 1, 0.5, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, FIVE_ON_SIDES, 0, 0));
        panel.add(cancel, new GridBagConstraints(1, 1, GridBagConstraints.REMAINDER, 1, 0.5, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, FIVE_ON_SIDES, 0, 0));
        setContentPane(panel);
        getRootPane().setDefaultButton(ok);
        pack();
        setLocation(parent.getX() + (parent.getWidth() / 2) - (getWidth() / 2), parent.getY() + (parent.getHeight() / 2) - (getHeight() / 2));
        setVisible(true);
    }

    public int getResult() {
        return result;
    }

    public int getInputSize() {
        int size = Integer.parseInt(field.getText());
        return size == 0 ? 1 : size;
    }

}
